import os
import unittest
import sys
import template_to_pepp_text

import requests_mock

##Tests written by Colin. I didn't write this file though.

@requests_mock.Mocker()
class TestTemplate(unittest.TestCase):
    def test_get_list_of_seeds_one_seed(self,m):
        self.assertEquals(template_to_pepp_text.get_list_of_seeds("template"), ['"weather"'])

    def test_get_list_of_seed(self,m):
        self.assertEquals(template_to_pepp_text.get_list_of_seeds("template2"), ['"weather"', '"finance"', '"openhab"'])
        self.assertEquals(template_to_pepp_text.get_list_of_seeds("template3"), ['"weather"', '"finance"', '"openhab"'])

    def test_retrieve_data(self,m):
        m.register_uri('GET',template_to_pepp_text.host+template_to_pepp_text.extension+"weather",json={"name":"weather","data":{"High":84,"Low":45}})
        self.assertEquals(template_to_pepp_text.get_data_from_database(['"weather"']),{"weather":{"High":84,"Low":45}})

    def test_retrieve_data_fails(self,m):
        m.register_uri('GET',template_to_pepp_text.host+template_to_pepp_text.extension+"weather",status_code=400)
        with self.assertRaises(RuntimeError):
            template_to_pepp_text.get_data_from_database(['"weather"'])

    def test_making_text(self,m):
        p = template_to_pepp_text.make_text({"weather":{"High":84,"Low":45}},"template")
        self.assertEquals(p,"Hi Colin, the Temperature is super Hot fire, with the high as high as 84 degrees fah"
                            "renheit.")

    def test_making_text_in_file(self,m):
        try:
            os.remove("template.txt")
        except OSError as e:
            pass
        p = template_to_pepp_text.generate_pepp_text("template",{"weather":{"High":84,"Low":45}})
        f = open("template.txt")
        p = f.read()
        self.assertEquals(p,"Hi Colin, the Temperature is super Hot fire, with the high as high as 84 degrees fah"
                            "renheit.")

    def test_whole_thing(self,m):
        try:
            os.remove("template.txt")
        except OSError as e:
            pass
        m.register_uri('GET',template_to_pepp_text.host+template_to_pepp_text.extension+"weather",json={"name":"weather","data":{"High":84,"Low":45}})
        sys.argv[1] = "template"
        template_to_pepp_text.main()
        f = open("template.txt")
        p = f.read()
        self.assertEquals(p,"Hi Colin, the Temperature is super Hot fire, with the high as high as 84 degrees fah"
                            "renheit.")